#include <iostream>
#include <vector>
using namespace std;
int red(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] == 'R' && dostup[x1][y1 - 1] == 0){
        s += red(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] == 'R' && dostup[x1][y1 + 1] == 0){
        s += red(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] == 'R' && dostup[x1 - 1][y1] == 0){
        s += red(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] == 'R' && dostup[x1 + 1][y1] == 0){
        s += red(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int blue(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] == 'B' && dostup[x1][y1 - 1] == 0){
        s += blue(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] == 'B' && dostup[x1][y1 + 1] == 0){
        s += blue(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] == 'B' && dostup[x1 - 1][y1] == 0){
        s += blue(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] == 'B' && dostup[x1 + 1][y1] == 0){
        s += blue(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int green(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] == 'G' && dostup[x1][y1 - 1] == 0){
        s += green(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] == 'G' && dostup[x1][y1 + 1] == 0){
        s += green(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] == 'G' && dostup[x1 - 1][y1] == 0){
        s += green(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] == 'G' && dostup[x1 + 1][y1] == 0){
        s += green(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int orange(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] == 'O' && dostup[x1][y1 - 1] == 0){
        s += orange(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] == 'O' && dostup[x1][y1 + 1] == 0){
        s += orange(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] == 'O' && dostup[x1 - 1][y1] == 0){
        s += orange(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] == 'O' && dostup[x1 + 1][y1] == 0){
        s += orange(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int rb(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && (v1[x1][y1 - 1] == 'R' || v1[x1][y1 - 1] == 'B') && dostup[x1][y1 - 1] == 0){
        s += rb(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && (v1[x1][y1] == 'R' || v1[x1][y1] == 'B') && dostup[x1][y1 + 1] == 0){
        s += rb(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && (v2[y1][x1 - 1] == 'R' || v2[y1][x1 - 1] == 'B') && dostup[x1 - 1][y1] == 0){
        s += rb(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && (v2[x1][y1] == 'R' || v2[x1][y1] == 'B') && dostup[x1 + 1][y1] == 0){
        s += rb(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int rg(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && (v1[x1][y1 - 1] == 'R' || v1[x1][y1 - 1] == 'G') && dostup[x1][y1 - 1] == 0){
        s += rg(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && (v1[x1][y1] == 'R' || v1[x1][y1] == 'G') && dostup[x1][y1 + 1] == 0){
        s += rg(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && (v2[y1][x1 - 1] == 'R' || v2[y1][x1 - 1] == 'G') && dostup[x1 - 1][y1] == 0){
        s += rg(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && (v2[x1][y1] == 'R' || v2[x1][y1] == 'G') && dostup[x1 + 1][y1] == 0){
        s += rg(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int ro(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && (v1[x1][y1 - 1] == 'R' || v1[x1][y1 - 1] == 'O') && dostup[x1][y1 - 1] == 0){
        s += ro(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && (v1[x1][y1] == 'R' || v1[x1][y1] == 'O') && dostup[x1][y1 + 1] == 0){
        s += ro(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && (v2[y1][x1 - 1] == 'R' || v2[y1][x1 - 1] == 'O') && dostup[x1 - 1][y1] == 0){
        s += ro(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && (v2[x1][y1] == 'R' || v2[x1][y1] == 'O') && dostup[x1 + 1][y1] == 0){
        s += ro(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int bg(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && (v1[x1][y1 - 1] == 'B' || v1[x1][y1 - 1] == 'G') && dostup[x1][y1 - 1] == 0){
        s += bg(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && (v1[x1][y1] == 'B' || v1[x1][y1] == 'G') && dostup[x1][y1 + 1] == 0){
        s += bg(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && (v2[y1][x1 - 1] == 'B' || v2[y1][x1 - 1] == 'G') && dostup[x1 - 1][y1] == 0){
        s += bg(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && (v2[x1][y1] == 'B' || v2[x1][y1] == 'G') && dostup[x1 + 1][y1] == 0){
        s += bg(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int bo(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && (v1[x1][y1 - 1] == 'B' || v1[x1][y1 - 1] == 'O') && dostup[x1][y1 - 1] == 0){
        s += bo(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && (v1[x1][y1] == 'B' || v1[x1][y1] == 'O') && dostup[x1][y1 + 1] == 0){
        s += bo(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && (v2[y1][x1 - 1] == 'B' || v2[y1][x1 - 1] == 'O') && dostup[x1 - 1][y1] == 0){
        s += bo(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && (v2[x1][y1] == 'B' || v2[x1][y1] == 'O') && dostup[x1 + 1][y1] == 0){
        s += bo(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int go(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && (v1[x1][y1 - 1] == 'G' || v1[x1][y1 - 1] == 'O') && dostup[x1][y1 - 1] == 0){
        s += go(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && (v1[x1][y1] == 'G' || v1[x1][y1] == 'O') && dostup[x1][y1 + 1] == 0){
        s += go(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && (v2[y1][x1 - 1] == 'G' || v2[y1][x1 - 1] == 'O') && dostup[x1 - 1][y1] == 0){
        s += go(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && (v2[x1][y1] == 'G' || v2[x1][y1] == 'O') && dostup[x1 + 1][y1] == 0){
        s += go(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int rbg(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] != 'O' && dostup[x1][y1 - 1] == 0){
        s += rbg(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] != 'O' && dostup[x1][y1 + 1] == 0){
        s += rbg(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] != 'O' && dostup[x1 - 1][y1] == 0){
        s += rbg(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] != 'O' && dostup[x1 + 1][y1] == 0){
        s += rbg(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int rbo(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] != 'G' && dostup[x1][y1 - 1] == 0){
        s += rbo(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] != 'G' && dostup[x1][y1 + 1] == 0){
        s += rbo(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] != 'G' && dostup[x1 - 1][y1] == 0){
        s += rbo(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] != 'G' && dostup[x1 + 1][y1] == 0){
        s += rbo(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int rgo(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] != 'B' && dostup[x1][y1 - 1] == 0){
        s += rgo(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] != 'B' && dostup[x1][y1 + 1] == 0){
        s += rgo(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] != 'B' && dostup[x1 - 1][y1] == 0){
        s += rgo(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] != 'B' && dostup[x1 + 1][y1] == 0){
        s += rgo(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int bgo(int n, int m, vector<vector<int>> &dostup, int x1, int y1, int x2, int y2, vector<vector<char>>v1, vector<vector<char>>v2){
    dostup[x1][y1] = 1;
    int s = 0;
    if (x1 == x2 && y1 == y2){
        s += 1;
    }
    if (y1 > 0 && v1[x1][y1 - 1] != 'R' && dostup[x1][y1 - 1] == 0){
        s += bgo(n, m, dostup, x1, y1 - 1, x2, y2, v1, v2);
    }
    if (y1 < n - 1 && v1[x1][y1] != 'R' && dostup[x1][y1 + 1] == 0){
        s += bgo(n, m, dostup, x1, y1 + 1, x2, y2, v1, v2);
    }
    if (x1 > 0 && v2[y1][x1 - 1] != 'R' && dostup[x1 - 1][y1] == 0){
        s += bgo(n, m, dostup, x1 - 1, y1, x2, y2, v1, v2);
    }
    if (x1 < n - 1 && v2[x1][y1] != 'R' && dostup[x1 + 1][y1] == 0){
        s += bgo(n, m, dostup, x1 + 1, y1, x2, y2, v1, v2);
    }
    return s;
}
int main(){
    int n, m, q, x1, y1, x2, y2;
    cin >> n >> m;
    vector<vector<char>> v1(n, vector<char>(m - 1));
    vector<vector<char>> v2(m, vector<char>(n - 1));
    vector<vector<int>> dostup(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m - 1; j++){
            cin >> v1[i][j];
        }
    }
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n - 1; j++){
            cin >> v2[i][j];
        }
    }
    cin >> q;
    for (int i = 0; i < q; i++){
        cin >> x1 >> y1 >> x2 >> y2;
        vector<vector<int>> dostupr(n, vector<int>(m));
        vector<vector<int>> dostupb(n, vector<int>(m));
        vector<vector<int>> dostupg(n, vector<int>(m));
        vector<vector<int>> dostupo(n, vector<int>(m));
        vector<vector<int>> dostuprb(n, vector<int>(m));
        vector<vector<int>> dostuprg(n, vector<int>(m));
        vector<vector<int>> dostupro(n, vector<int>(m));
        vector<vector<int>> dostupbg(n, vector<int>(m));
        vector<vector<int>> dostupbo(n, vector<int>(m));
        vector<vector<int>> dostupgo(n, vector<int>(m));
        vector<vector<int>> dostuprbg(n, vector<int>(m));
        vector<vector<int>> dostuprbo(n, vector<int>(m));
        vector<vector<int>> dostuprgo(n, vector<int>(m));
        vector<vector<int>> dostupbgo(n, vector<int>(m));
        if (red(n, m, dostupr, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || blue(n, m, dostupb, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || green(n, m, dostupg, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || orange(n, m, dostupo, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0){
            cout << 1 << endl;
        } else if (rb(n, m, dostuprb, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || rg(n, m, dostuprg, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || ro(n, m, dostupro, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || bg(n, m, dostupbg, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || bo(n, m, dostupbo, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || go(n, m, dostupgo, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0){
            cout << 2 << endl;
        } else if (rbg(n, m, dostuprbg, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || rbo(n, m, dostuprbo, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || rgo(n, m, dostuprgo, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0 || bgo(n, m, dostupbgo, x1 - 1, y1 - 1, x2 - 1, y2 - 1, v1, v2) > 0){
            cout << 3 << endl;
        } else {
            cout << 4 << endl;
        }
    }
}
